#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <Xfwf/Board.h>
#include <X11/Xaw/Command.h>

static XtAppContext app_context;
static Widget toplevel, tester, sub1, sub2, sub3, expl;

static String fallback_resources[] = {
    "BoardT.width: 550",
    "BoardT.height: 300",

    "*borderWidth: 0",
    "*frameWidth: 2",

    "*tester.outerOffset: 6",
    "*tester.width: 300",
    "*tester.height: 300",
    "*tester.cursor: spider",
    "*tester.frameWidth: 2",
    "*tester.frameType: sunken",

    /* equivalent: *sub1.location: 20 20 1.0-40 70 */
    "*sub1.abs_x: 20",
    "*sub1.abs_y: 20",
    "*sub1.abs_height: 70",
    "*sub1.rel_height: 0.0",
    "*sub1.rel_width: 1.0",
    "*sub1.abs_width: -40",

    "*sub2.location: 0.5-40 100 80 165-0.2",
    "*sub2.background: seagreen",

    "*sub3.location: 0.5-40 275-0.2 80 1.2-295",
    "*sub3.cursor: coffee_mug",

    "*explain.label: Resize window to see widgets change; click = stop",
    "*explain.x: 10",
    "*explain.y: 10",
    "*explain.width: 300",
    "*explain.height:40",

    NULL,
};

/* ARGSUSED */
void quit(w, client_data, call_data)
    Widget w;
    XtPointer client_data, call_data;
{
    exit(0);
}

void main(argc, argv)
    int argc;
    char *argv[];
{
    toplevel = XtVaAppInitialize(&app_context, "BoardT", NULL, 0,
				  &argc, argv, fallback_resources, NULL);
    tester = XtVaCreateManagedWidget("tester", xfwfBoardWidgetClass,
				     toplevel, NULL);
    sub1 = XtVaCreateManagedWidget("sub1", xfwfBoardWidgetClass, tester, NULL);
    sub2 = XtVaCreateManagedWidget("sub2", xfwfBoardWidgetClass, tester, NULL);
    sub3 = XtVaCreateManagedWidget("sub3", xfwfBoardWidgetClass, tester, NULL);
    expl = XtVaCreateManagedWidget("explain", commandWidgetClass, sub1, NULL);
    XtAddCallback(expl, XtNcallback, quit, NULL);
    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
