/*
 * Copyright (c) 1992, 1993 Arno Augustin, Frank Hoering, University of
 * Erlangen-Nuremberg, Germany.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	Erlangen-Nuremberg, Germany.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
 * EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define connect_width 40
#define connect_height 32
static char connect_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xff, 0x7f, 0x00, 0x80, 0xff,
   0xff, 0xff, 0x01, 0xe0, 0x01, 0x00, 0x80, 0x07, 0x70, 0x00, 0x00, 0x00,
   0x0e, 0x18, 0x00, 0x00, 0x00, 0x18, 0x18, 0x78, 0x00, 0x00, 0x18, 0x0c,
   0x7c, 0xfe, 0xff, 0x31, 0x0c, 0x7e, 0xfe, 0xff, 0x31, 0x0c, 0x7f, 0x00,
   0x00, 0x30, 0x06, 0x7f, 0x00, 0x00, 0x60, 0x86, 0x63, 0x00, 0x00, 0x60,
   0x86, 0x03, 0xfe, 0x3f, 0x60, 0x86, 0x03, 0xfe, 0x3f, 0x60, 0x86, 0x03,
   0x00, 0x00, 0x60, 0x86, 0x03, 0x00, 0x00, 0x60, 0x86, 0x03, 0x00, 0x00,
   0x60, 0x86, 0x03, 0xfe, 0x01, 0x60, 0x86, 0x03, 0xfe, 0x01, 0x60, 0x86,
   0x03, 0x00, 0x00, 0x60, 0x86, 0x63, 0x00, 0x00, 0x60, 0x04, 0x7f, 0x00,
   0x00, 0x20, 0x0c, 0x7f, 0x00, 0x00, 0x30, 0x0c, 0x7e, 0xfe, 0xff, 0x31,
   0x0c, 0x7c, 0xfe, 0xff, 0x31, 0x18, 0x78, 0x00, 0x00, 0x18, 0x18, 0x00,
   0x00, 0x00, 0x18, 0x70, 0x00, 0x00, 0x00, 0x0e, 0xe0, 0x01, 0x00, 0x80,
   0x07, 0x80, 0xff, 0xff, 0xff, 0x01, 0x00, 0xfe, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00};
#define disconnect_width 40
#define disconnect_height 32
static char disconnect_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0xfe, 0xff, 0x7f, 0xf8, 0x80, 0xff,
   0xff, 0xff, 0xfd, 0xe0, 0x01, 0x00, 0x80, 0x7f, 0x70, 0x00, 0x00, 0x80,
   0x3f, 0x18, 0x00, 0x00, 0xc0, 0x1f, 0x18, 0x78, 0x00, 0xe0, 0x1f, 0x0c,
   0x7c, 0xfe, 0xff, 0x33, 0x0c, 0x7e, 0xfe, 0xff, 0x31, 0x0c, 0x7f, 0x00,
   0xfe, 0x30, 0x06, 0x7f, 0x00, 0x7f, 0x60, 0x86, 0x63, 0x80, 0x3f, 0x60,
   0x86, 0x03, 0xfe, 0x3f, 0x60, 0x86, 0x03, 0xfe, 0x3f, 0x60, 0x86, 0x03,
   0xfc, 0x07, 0x60, 0x86, 0x03, 0xfe, 0x01, 0x60, 0x86, 0x03, 0xff, 0x00,
   0x60, 0x86, 0x83, 0xff, 0x01, 0x60, 0x86, 0xe3, 0xff, 0x01, 0x60, 0x86,
   0xf3, 0x07, 0x00, 0x60, 0x86, 0xfb, 0x03, 0x00, 0x60, 0x04, 0xff, 0x01,
   0x00, 0x20, 0x0c, 0xff, 0x00, 0x00, 0x30, 0x8c, 0x7f, 0xfe, 0xff, 0x31,
   0xcc, 0x7f, 0xfe, 0xff, 0x31, 0xf8, 0x7f, 0x00, 0x00, 0x18, 0xf8, 0x03,
   0x00, 0x00, 0x18, 0xfc, 0x01, 0x00, 0x00, 0x0e, 0xfe, 0x01, 0x00, 0x80,
   0x07, 0xbf, 0xff, 0xff, 0xff, 0x01, 0x1f, 0xfe, 0xff, 0x7f, 0x00, 0x0f,
   0x00, 0x00, 0x00, 0x00};
#define tia_width 40
#define tia_height 32
static char tia_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xff, 0x7f, 0x00, 0x80, 0xff,
   0xff, 0xff, 0x01, 0xe0, 0xff, 0xff, 0xff, 0x07, 0xf0, 0xff, 0xff, 0xff,
   0x0f, 0xf8, 0xff, 0xff, 0xff, 0x1f, 0xf8, 0xff, 0xff, 0xff, 0x1b, 0xfc,
   0xff, 0xff, 0xff, 0x30, 0xfc, 0xff, 0xff, 0x3f, 0x30, 0xfc, 0xff, 0xff,
   0x1f, 0x30, 0xfe, 0xff, 0xff, 0x0f, 0x60, 0xfe, 0xff, 0xff, 0x07, 0x60,
   0xfe, 0xff, 0xff, 0x03, 0x60, 0xfe, 0xff, 0xff, 0x00, 0x60, 0xfe, 0xff,
   0x7f, 0x00, 0x60, 0xfe, 0xff, 0x3f, 0x00, 0x60, 0xfe, 0xff, 0x1f, 0x00,
   0x60, 0xfe, 0xff, 0x07, 0x00, 0x60, 0xfe, 0xff, 0x03, 0x00, 0x60, 0xfe,
   0xff, 0x01, 0x00, 0x60, 0xfe, 0x7f, 0x00, 0x00, 0x60, 0xfc, 0x3f, 0x00,
   0x00, 0x20, 0xfc, 0x1f, 0x00, 0x00, 0x30, 0xfc, 0x07, 0x00, 0x00, 0x30,
   0xfc, 0x03, 0x00, 0x00, 0x30, 0xf8, 0x01, 0x00, 0x00, 0x18, 0x78, 0x00,
   0x00, 0x00, 0x18, 0x30, 0x00, 0x00, 0x00, 0x0e, 0xe0, 0x01, 0x00, 0x80,
   0x07, 0x80, 0xff, 0xff, 0xff, 0x01, 0x00, 0xfe, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00};
#define reveal_width 40
#define reveal_height 32
static char reveal_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xff, 0x7f, 0x00, 0x80, 0xff,
   0xff, 0xff, 0x01, 0xe0, 0x01, 0x60, 0x80, 0x07, 0x70, 0x00, 0x30, 0x00,
   0x0e, 0x18, 0x00, 0x38, 0x00, 0x18, 0xd8, 0xff, 0x2f, 0x00, 0x18, 0xec,
   0xff, 0x27, 0x00, 0x30, 0x0c, 0x00, 0x23, 0x00, 0x30, 0x0c, 0x80, 0x21,
   0x00, 0x30, 0xe6, 0xff, 0x20, 0x00, 0x60, 0xe6, 0x3f, 0x20, 0x00, 0x60,
   0x06, 0x18, 0x20, 0x00, 0x60, 0x06, 0x08, 0x20, 0x00, 0x60, 0xe6, 0x07,
   0x20, 0x00, 0x60, 0xe6, 0x03, 0x20, 0x00, 0x60, 0x86, 0x01, 0x20, 0x00,
   0x60, 0xc6, 0x00, 0x20, 0x00, 0x60, 0x66, 0x00, 0x20, 0x00, 0x60, 0xf6,
   0xff, 0x3f, 0x00, 0x60, 0x1e, 0x00, 0x00, 0x00, 0x60, 0x0c, 0x00, 0x00,
   0x00, 0x20, 0x0c, 0x00, 0x00, 0x00, 0x30, 0x0c, 0x00, 0x00, 0x00, 0x30,
   0x0c, 0x00, 0x00, 0x00, 0x30, 0x18, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00,
   0x00, 0x00, 0x18, 0x70, 0x00, 0x00, 0x00, 0x0e, 0xe0, 0x01, 0x00, 0x80,
   0x07, 0x80, 0xff, 0xff, 0xff, 0x01, 0x00, 0xfe, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00};
#define icon_width 32
#define icon_height 32
static char icon_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0xf8, 0xff, 0xff, 0x1f, 0x04, 0x00, 0x00, 0x20,
   0x04, 0xff, 0xff, 0x20, 0x84, 0x07, 0xe0, 0x21, 0x84, 0xfb, 0xdf, 0x21,
   0x04, 0x7d, 0xbe, 0x20, 0x04, 0x3c, 0x3c, 0x20, 0x04, 0x7e, 0x7e, 0x20,
   0x04, 0xfe, 0x7f, 0x20, 0x04, 0x00, 0x00, 0x20, 0x34, 0x12, 0x02, 0x20,
   0xb4, 0xda, 0xd6, 0x26, 0xb4, 0xda, 0x56, 0x26, 0x0c, 0x00, 0x00, 0x30,
   0xf0, 0xff, 0xff, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0xfe, 0xff, 0xff, 0x7f, 0x00, 0x00, 0x00, 0x00,
   0x8c, 0x02, 0x44, 0x15, 0xac, 0x6a, 0x45, 0x15, 0x00, 0x00, 0x00, 0x00,
   0xfe, 0xff, 0xff, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
#define cursor_width 2
#define cursor_height 2
static char cursor_bits[] = {
   0x01, 0x02};

/*
#define empty_width 40
#define empty_height 32
static char empty_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xff, 0x7f, 0x00, 0x80, 0xff,
   0xff, 0xff, 0x01, 0xe0, 0x01, 0x00, 0x80, 0x07, 0x70, 0x00, 0x00, 0x00,
   0x0e, 0x18, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x18, 0x0c,
   0x00, 0x00, 0x00, 0x30, 0x0c, 0x00, 0x00, 0x00, 0x30, 0x0c, 0x00, 0x00,
   0x00, 0x30, 0x06, 0x00, 0x00, 0x00, 0x60, 0x06, 0x00, 0x00, 0x00, 0x60,
   0x06, 0x00, 0x00, 0x00, 0x60, 0x06, 0x00, 0x00, 0x00, 0x60, 0x06, 0x00,
   0x00, 0x00, 0x60, 0x06, 0x00, 0x00, 0x00, 0x60, 0x06, 0x00, 0x00, 0x00,
   0x60, 0x06, 0x00, 0x00, 0x00, 0x60, 0x06, 0x00, 0x00, 0x00, 0x60, 0x06,
   0x00, 0x00, 0x00, 0x60, 0x06, 0x00, 0x00, 0x00, 0x60, 0x04, 0x00, 0x00,
   0x00, 0x20, 0x0c, 0x00, 0x00, 0x00, 0x30, 0x0c, 0x00, 0x00, 0x00, 0x30,
   0x0c, 0x00, 0x00, 0x00, 0x30, 0x18, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00,
   0x00, 0x00, 0x18, 0x70, 0x00, 0x00, 0x00, 0x0e, 0xe0, 0x01, 0x00, 0x80,
   0x07, 0x80, 0xff, 0xff, 0xff, 0x01, 0x00, 0xfe, 0xff, 0x7f, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00};
*/

#define dimple1_width 16
#define dimple1_height 16
static char dimple1_bits[] = {
   0x55, 0x55, 0x00, 0x00, 0x55, 0x55, 0x00, 0x00, 0x55, 0x55, 0x00, 0x00,
   0x55, 0x55, 0x00, 0x00, 0x55, 0x55, 0x00, 0x00, 0x55, 0x55, 0x00, 0x00,
   0x55, 0x55, 0x00, 0x00, 0x55, 0x55, 0x00, 0x00};
#define chsize_width 40
#define chsize_height 32
static char chsize_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfc, 0xff, 0x7f, 0x00, 0x00,
   0xfc, 0xff, 0x7f, 0x00, 0x00, 0x0c, 0x00, 0x60, 0x00, 0x00, 0x0c, 0x00,
   0x60, 0x00, 0x00, 0x0c, 0x00, 0x60, 0x00, 0x00, 0x0c, 0x00, 0x60, 0x00,
   0x00, 0x0c, 0x00, 0x60, 0x00, 0x00, 0x0c, 0x00, 0x60, 0x00, 0x00, 0x0c,
   0x00, 0x60, 0x00, 0x00, 0x0c, 0x00, 0x60, 0x00, 0x00, 0x0c, 0x00, 0x60,
   0x00, 0x00, 0x0c, 0x00, 0x60, 0x00, 0x00, 0xfc, 0xff, 0x7f, 0x00, 0x00,
   0xfc, 0xff, 0x7f, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x0e, 0x00,
   0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x80, 0x01, 0x00, 0x00, 0x00,
   0xd0, 0x00, 0x00, 0x00, 0x00, 0x70, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00,
   0x00, 0x00, 0xfe, 0x3f, 0x00, 0x00, 0x00, 0xfe, 0x3f, 0x00, 0x00, 0x00,
   0x06, 0x30, 0x00, 0x00, 0x00, 0x06, 0x30, 0x00, 0x00, 0x00, 0x06, 0x30,
   0x00, 0x00, 0x00, 0x06, 0x30, 0x00, 0x00, 0x00, 0x06, 0x30, 0x00, 0x00,
   0x00, 0xfe, 0x3f, 0x00, 0x00, 0x00, 0xfe, 0x3f, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00};
