.Id $Id: atrun.man,v 1.1 1994/05/10 18:23:08 kernel Exp kernel $
.TH ATRUN 8 "Jan 1993" local "Linux Programmer's Manual"
.SH NAME
atrun \- run jobs queued for later execution
.SH SYNOPSIS
.B atrun
.RB [ -l
.IR load_avg ]
.RB [ -d ]
.SH DESCRIPTION
.B atrun
runs jobs queued by
.BR at(1) .
Root's crontab file has to contain the line
.br
.B * * * * * _ATLIB_DIR/atrun
.br
so
.B _ATLIB_DIR/atrun
gets called once a minute.
.PP
At every invocation, every job in lowercase queues whose starting time
has passed is started.
A maximum of one batch jobs (denoted by uppercase queues) are started
each time
.B atrun
is invoked.
.SH OPTIONS
.TP 8
.B -l
Specifies a limiting load factor, over which batch jobs should
not be run, instead of the compiled \- in value of _LOADAVG_MX.
.TP 8
.B -d
Debug; print error messages to standard error instead of using
.BR syslog(3) .
.SH WARNINGS
For
.B atrun
to work, you have to start up a
.B cron
daemon.
.SH FILES
.I _ATSPOOL_DIR/
.br
.I _ATJOB_DIR/
.SH SEE ALSO
at(1), cron(1), crontab(1), syslog(3)
.SH BUGS
The functionality of 
.B atrun
should be merged into
.BR cron(1) .
