/*
    Pirate Bulletin Board System
    Copyright (C) 1990, Edward Luke, lush@Athena.EE.MsState.EDU
    Eagles Bulletin Board System
    Copyright (C) 1992, Raymond Rocker, rocker@rock.b11.ingr.com
                        Guy Vega, gtvega@seabass.st.usm.edu
                        Dominic Tynes, dbtynes@seabass.st.usm.edu

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef BBSIRC

/* EBBS CONFIGURATION VARIABLES */

/*
   This is optional, *except for Linux!!!* On most systems the system will
   look up the local Internet address. On Linux gethostbyname() won't work
   in the chrooted environment, and until I figure out why, you need this.
   I don't think there's any problem leaving this as is.
*/

#define INET_ADDRESS  "127.0.0.1"

/* 
   Define this to enable wide character support for Chinese or other 
   languages not using the 7-bit character set. Comment out if this isn't
   needed. 
*/
/* #define BIT8 */

/* 
   The bbs looks for the BoardName file first to get the name of the bbs...
   if that fails it uses the name defined here. Don't comment out. 
*/
#define BOARDNAME	"The Unknown BBS"

/* 
   You may define a default board here, already selected when a user logs in.
   If this is set to the empty string, the bbs will require users to (S)elect
   a board before reading or posting. Don't comment this out. 
*/
#define DEFAULTBOARD	""

/* 
   You get this many chances to give a valid userid/password combination
   before the bbs squawks at you and closes the connection. 
   Don't comment out. 
*/
#define LOGINATTEMPTS 3

/* 
   Turn this on to allow users to create their own accounts by typing 'new'
   at the "Enter userid:" prompt. Comment out to restrict access to accounts
   created by the Sysop.
*/
#define LOGINASNEW 1

/* 
   Defined means user may log as as many times as they wish, simultaneously.
   On a large bbs with many window-users you probably want this off.
   Comment out to disable.
*/
#define MULTI_LOGINS 1

/* 
Comment this out to disable the Voting stuff. Dunno why, it's not a resource
hog or anything, but if you don't want it...
*/
#define VOTE	1

/* 
   Define this if you want the Internet Post/Mail Forwarding features
   enabled. You MUST have the sendmail(8) program on your system or
   the mail.sh script in this distribution in a cron job to run the 
   bbs mail queue every so often. The bbs does not invoke sendmail, 
   it simply creates the queue and data files for it. 
*/
#define INTERNET_EMAIL 1

#ifdef INTERNET_EMAIL
/* If you defined INTERNET_EMAIL, you have the option of telling the bbs
   an address where failed forwarded messages can go to (people will 
   invariably set their addresses wrong!). If this is commented out bounces
   should go to the bbs mailbox in the usual mail spool. 
*/
#define ERRORS_TO "root"
#endif

/* 
   Define DOTIMEOUT to set a timer to log out users who sit idle on the system.
   Then decide how long to let them stay: MONITOR_TIMEOUT is the time in
   seconds a user can sit idle in Monitor mode; IDLE_TIMEOUT applies to all
   other modes. 
*/
#define DOTIMEOUT 1

/* 
   These are moot if DOTIMEOUT is commented; leave them defined anyway. 
   I never got around to proper ifdef-ing.
*/
#define IDLE_TIMEOUT (60*15) 
#define MONITOR_TIMEOUT (60*30) 

/* 
   This defines the set of characters disallowed in chat id's. These
   characters get translated to underscores (_) when someone tries to use
   them. At the very least you should disallow spaces and '*'.
*/ 
#define BADCIDCHARS " *"

/* 
   If Chat-3 is going to be a privileged Chat room, define this to Cloak
   users on entry to it.
*/
/* #define CHAT3_CLOAKED	1 */

/* 
   Ditto above for Chat-4
*/
/* #define CHAT4_CLOAKED	1 */

/* 
   By default, users with post permission can reply to a post right after
   they read it. This can lead to lots of silly replies, hence the reply
   feature is a little controversial. Uncomment this to disable Reply. 
*/
/* #define NOREPLY 1 */

/* 
   Comment this out to disable the UL/DL functions. NOTICE: Everything inside
   these guards are unchanged from PBBS 1.6, since we did not support UL/DL
   on the Eagle's Nest. Use at your own risk.
*/
#define FILES	1

/* 
   Define this if you are going to install an Internet Relay Chat client
   and/or server. Either the one with this distribution or a newer one. 
*/
/* #define IRC   1 */

#ifdef IRC  /* If so you must give the server name here... */
#define IRC_SERVER ""
#endif

/* 
   Here is where you pick the shell spawned from the Admin menu shell escape.
   Usually it will be csh. But pick another if you like. 
   Don't comment out.
   NOTE: Be sure you set the same shell in the Makefile.
*/

#define ESCAPE_SHELL "csh"

/***************************************************************************
BBSDOORS and MMMM are contributed by Bill Schwartz <schwartz@augsburg.edu>.
These were added right before the 2.0 release and are pretty much verbatim 
as contributed; also you'll have to install the programs and directories for
these two options by hand. Instructions are in README.install.

(I guess my point is...these are new to me so I don't guarantee them :)
****************************************************************************/

/*
   Define this if you want to set up doors to other systems via the BBSNet
   script. You'll need to customize and install the bbsnet script, and copy 
   more programs into the bbs subtree. See README.install for details.
*/
/* #define BBSDOORS	1 */

/*
   Define this if you want the hooks for the 4m Intercom chat system, a new
   IRC-like multisite chat system. The 4m program is NOT provided with this
   distribution; see README.install for information on where to get it and
   how to set it up.
*/
/* #define MMMM		1 */

/****************************************************************************/

#define MAXUSERS 780   /* Maximum number of users,780 makes file structures 1k*/
#define MAXBOARD 80    /* Maximum number of boards */
#define MAXACTIVE 40   /* Max users allowed on the system at once. Set this
			  to a reasonable value based on the resources of
			  your system. */


#define PERMS 1        /* To use the new improved method of access control.
                          Definitely define this if you're a first time
                          EBBS user. If you are running EBBS already 
			  commenting this out will preserve compatibility --
			  but the old method may not be supported in the
  			  future. The conversion process is straightforward. */

#ifndef PERMS
/* What level can do what? Some define here, others in comm_lists.c and
   help.c. Don't comment these out. */

#define CLOAK	10	   /* level to cloak */
#define SEE_CLOAK 20       /* level to see cloakers */
#define DELPOSTLEVEL 50    /* level to delete others' posts */
#define SEEBRDLEVELS 50   /* level to see levels on boards */
#define SEEUSRLEVELS 255   /* level to see user levels */
#define CLOAKONLOGIN 30   /* level to auto-cloak on login */
#define MULTILOGOK   255   /* level to override multi-login restriction */
			   /* (if any) */
#endif

#define MAXSIGLINES 4	 /* max. # of lines appended for post signature */
#define MAXQUERYLINES 15 /* max. # of lines shown by the Query function */

#endif /* !BBSIRC */

/* Once you set this, do not change it unless you are restarting your
   bbs from scratch! The PASSWDS file will not work if this is changed.
   If commented out, no real name/address info can be kept in the passwd
   file. Pretty useless to have this if LOGINASNEW is defined. */

#define REALINFO	1

#ifdef REALINFO    /* Options to control who sees real names */

/* 
Define this to show real names in the Main Menu user list. 
*/
/* #define ACTS_REALNAMES	1 */

/* 
Define this to show real names in post headers. 
*/
/* #define POSTS_REALNAMES 1 */

/* 
Define this to show real names in mail messages. 
*/
/* #define MAIL_REALNAMES 1 */

/* 
Define this for Query to show real names. 
*/
/* #define QUERY_REALNAMES	1 */

#endif /* REALINFO */
