#
# Copyright (c) 1987, 1989 University of Maryland
# Department of Computer Science.  All rights reserved.
# Permission to copy for any purpose is hereby granted
# so long as this copyright notice remains intact.
#
# /usr/local/src/CVS/eps/dvi/makefile.tcc,v 1.1.1.1 1993/10/02 01:50:16 neal Exp
#
# Makefile for ctex/dvi (DVI-to-DVI conversion programs)
#
CFLAGS=	-mc -P -O -2 -I../h

CC=tcc
DESTDIR=
#SHELL=	/bin/sh

LIBS=	../lib/lib.lib

# these are intended to be overridden by the definitions in ../Makefile
# but just in case, they are here too
BINDIR=	${DESTDIR}/usr/local/bin
MANDIR=	${DESTDIR}/usr/local/man
INSTALL=install

SRCS=	dviconcat.c dviselect.c
PROGS=	dviconcat.exe dviselect.exe

all: ${PROGS}

install:
	for i in ${PROGS}; do \
	    ${INSTALL} -s -o bin -g bin $$i ${BINDIR}/$$i; done
	${INSTALL} -c -o bin -g bin -m 444 dviconcat.1 ${MANDIR}/man1
	${INSTALL} -c -o bin -g bin -m 444 dviselect.1 ${MANDIR}/man1

clean:
	rm -f core *.o *.bak ${PROGS}

cleandir: clean
	rm -f .depend

depend: ${SRCS}
	mkdep ${CFLAGS} ${SRCS}

lint: ${SRCS}
	lint ${LINTFL} dviconcat.c
	lint ${LINTFL} dviselect.c

dviconcat.exe: dviconcat.obj ${LIBS}
	${CC} ${CFLAGS} dviconcat.obj ${LIBS}

dviselect.exe: dviselect.obj ${LIBS}
	${CC} ${CFLAGS} dviselect.obj ${LIBS}

