/* Copyright (c) 1993 Neal Becker
 * All rights reserved.
 * Permission to copy for any purpose is hereby granted
 * so long as this copyright notice remains intact.
 */

/* epsl.l,v 1.3 1993/10/02 03:23:10 neal Exp */

%{
#include "param.h"
#include "epsy.h"
int LineNo = 1;
%}

ID	[a-zA-Z0-9\\_.-]+

%%

engine { return ENGINE; }

vpins { return VPINS; }

dpih { return DPIH; }

dpiv { return DPIV; }

graphicsmode { return GRAPHICSMODE; }

vskip { return VSKIP; }

vinc { return VINC; }

hinc { return HINC; }

vinterleave { return VINTERLEAVE; }

xoff { return XOFF; }

yoff { return YOFF; }

width { return WIDTH; }

height { return HEIGHT; }

initstring { return INITSTRING; }

resetstring { return RESETSTRING; }

useescf0 { return USEESCF0; }

usetabs { return USETABS; }

usespaces { return USESPACES; }

minskipspaces { return MINSKIPSPACES; }

vspread { return VSPREAD; }

vaddvstr { return VADDVSTR; }

				/* eat comments */
#.* ;
				/* Allow strings to be quoted with either
				 single or double quotes */
\"[^"\n]*\" {
	  yylval.strval = (char *)malloc(yyleng-1); /* should check result! */
	  strncpy(yylval.strval,&(yytext[1]),yyleng-2);
	  (yylval.strval)[yyleng-2] = 0;
	  return(STRING);
	}

\'[^'\n]*\' {
	  yylval.strval = (char *)malloc(yyleng-1); /* should check result! */
	  strncpy(yylval.strval,&(yytext[1]),yyleng-2);
	  (yylval.strval)[yyleng-2] = 0;
	  return(STRING);
	}

{ID}	{
	  yylval.strval = strdup( yytext );
	  return(STRING);
	}

[ \t]+ ;

[\n]  { LineNo++; }

. {  return yytext[0]; }
%%
