/*
**
** xfader.c
**
** "Sanfter Einstieg"
** Text- und Grafikbildschirme langsam ein- und ausblenden
** MS-DOS/Pascal Version von Michael Philipp c't 10/93
**
** Linux-Version (X/Athena-Widgets)
** von Klaus Thiele, Huenstetten
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <errno.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Scrollbar.h>
#include "fader.h"

#define APPL_CLASS	"XFader"

float	fff =	100.0/MaxInten;
char	str[4];

void	quitCB( ),
	scrollCB( ),
	jumpCB( );

static	XtActionsRec	actions[] = {
        { "quit",		(XtActionProc) quitCB },
      };

XtAppContext		appContext;
Widget			widTopLevel;
Widget			widForm, widLabelA, widLabelB, widQuit, widFader;
int			nargs;
Arg			arg[10];


void main( int argc, char **argv ) {

     if( ioperm( PelIdxR, 1, 1 ) ) {
 	perror( "ioperm" );
 	exit ( 1 );
     }
 	
     ioperm( PelIdxW, 1, 1 );
     ioperm( PelData, 1, 1 );    

     InitCol( );

     widTopLevel = XtAppInitialize(
     				(XtAppContext *)	&appContext, 
				(String)	 	APPL_CLASS,
				(XrmOptionDescList)	NULL,
				(Cardinal)		0,
     				(int *)			&argc,
     				(String *)		argv,
     				(String *)		NULL,
     				(ArgList)		NULL,
     				(Cardinal)		0 );

     XtAppAddActions( appContext, actions, XtNumber(actions) );

     widForm = XtCreateManagedWidget( "mainForm",
				       formWidgetClass,
				       widTopLevel,
				       (ArgList)NULL,
				       0 );

     XtSetArg( arg[0], XtNleft, XtChainLeft );
     XtSetArg( arg[1], XtNright, XtChainLeft);
     XtSetArg( arg[2], XtNtop, XtChainTop );
     XtSetArg( arg[3], XtNbottom, XtChainTop );
     XtSetArg( arg[4], XtNborderWidth, 0 );
     widLabelA = XtCreateManagedWidget( "literal",
				        labelWidgetClass,
				        widForm,
				        (ArgList)arg,
				        5 ); 

     sprintf( &str[0], "%03d", (int)rint((double)(100.00/fff)) );
     XtSetArg( arg[4], XtNborderWidth, 1 );
     XtSetArg( arg[5], XtNlabel, &str[0] );
     XtSetArg( arg[6], XtNfromHoriz, widLabelA );
     widLabelB = XtCreateManagedWidget( "value",
				        labelWidgetClass,
				        widForm,
				        (ArgList)arg,
				        7 ); 

     XtSetArg( arg[5], XtNfromHoriz, widLabelB );
     widFader = XtCreateManagedWidget( "scrollbar",
				        scrollbarWidgetClass,
				        widForm,
				        (ArgList)arg,
				        6 );
     XtAddCallback( widFader, XtNjumpProc, (XtCallbackProc)jumpCB, NULL );
     XtAddCallback( widFader, XtNscrollProc, (XtCallbackProc)scrollCB, NULL );

     XtSetArg( arg[4], XtNfromVert, widLabelA );				       
     widQuit = XtCreateManagedWidget ( "quit_button",
				       commandWidgetClass,
				       widForm,
				       (ArgList)arg,
				       5 );				       
     XtAddCallback( widQuit, XtNcallback, (XtCallbackProc)quitCB, NULL );

     XtRealizeWidget( widTopLevel );

     XtAppMainLoop( appContext );

}

void scrollCB( Widget w, caddr_t ClientData, caddr_t pos ) {
   return; /* unused */
}

void jumpCB( Widget w, caddr_t ClientData, caddr_t prz ) {
int	i;

	i = (int)(((*(float *)prz)* 100)/fff)+1; 
	sprintf( &str[0], "%03d", i );
	XtSetArg( arg[0], XtNlabel, &str[0] );
	XtSetValues( widLabelB, arg, 1 ); 

	SetInten( (BYTE)i );

	return;
}

void quitCB( ) {
	SetInten( MaxInten );	/* sicherheitshalber wieder zuruecksetzen */
	exit( 0 );
}
