/*
**
** xmfader.c
**
** "Sanfter Einstieg"
** Text- und Grafikbildschirme langsam ein- und ausblenden
** MS-DOS/Pascal Version von Michael Philipp c't 10/93
**
** Linux-Version (OSF/Motif)
** von Klaus Thiele, Huenstetten
**
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/LabelG.h>
#include <Xm/PushB.h>
#include <Xm/Scale.h>
#include "fader.h"

#define APPL_CLASS	"XMFader"

#define HORIZ_OFFSET	10
#define LEFT_OFFSET	10
#define VERT_OFFSET	5
#define VERT_OFFSET_P	10

void	QuitCB( );
void	SliderMoveCB( );

XtAppContext		appContext;
Widget			widTopLevel;
Widget			widForm, widLabelA, widQuit, widFader;

void main( int argc, char **argv ) {

XmString xmTmpStr;

     if( ioperm( PelIdxR, 1, 1 ) ) {
 	perror( "ioperm" );
 	exit ( 1 );
     }
 	
     ioperm( PelIdxW, 1, 1 );
     ioperm( PelData, 1, 1 );    

     InitCol( ); 

     widTopLevel = XtAppInitialize(
     				(XtAppContext *)	&appContext, 
				(String)	 	APPL_CLASS,
				(XrmOptionDescList)	NULL,
				(Cardinal)		0,
     				(int *)			&argc,
     				(String *)		argv,
     				(String *)		NULL,
     				(ArgList)		NULL,
     				(Cardinal)		0 );

     xmTmpStr = XmStringCreateLtoR("Fader Version 1.0", 
				XmSTRING_DEFAULT_CHARSET);

     widForm = XtVaCreateManagedWidget( "mainForm",
			          xmFormWidgetClass,
				  widTopLevel,
			   	  XmNwidth, 230,
			 	  XmNheight, 110,
		   		  XmNdialogTitle, xmTmpStr,
		   		  XmNresizable, False,
				  NULL );
     XmStringFree(xmTmpStr);

     xmTmpStr = XmStringCreateLtoR("Helligkeitsregler", 
				XmSTRING_DEFAULT_CHARSET);

     widLabelA = XtVaCreateManagedWidget( "literal",
				    xmLabelGadgetClass,
				    widForm,
				    XmNlabelString, xmTmpStr,
				    XmNborderWidth, 0,
				    XmNleftAttachment, XmATTACH_FORM,
				    XmNtopAttachment, XmATTACH_FORM,
				    XmNtopOffset, VERT_OFFSET,
				    XmNleftOffset, LEFT_OFFSET,
				    NULL ); 
     XmStringFree(xmTmpStr);

     widFader = XtVaCreateManagedWidget( "scrollbar",
				   xmScaleWidgetClass,
				   widForm,
			   	   XmNwidth, 200,
				   XmNminimum, (int)0,
				   XmNmaximum, (int)MaxInten,
				   XmNvalue, (int)MaxInten,
				   XmNprocessingDirection, XmMAX_ON_RIGHT,
				   XmNborderWidth, 0,
				   XmNshowValue, True,
		   		   XmNorientation, XmHORIZONTAL,
		   		   XmNleftAttachment, XmATTACH_FORM,
		   		   XmNtopAttachment, XmATTACH_WIDGET,
		   		   XmNtopWidget, widLabelA,
		   		   XmNleftOffset, LEFT_OFFSET,
		   		   XmNtopOffset, VERT_OFFSET,
		   		   NULL );

     XtAddCallback( widFader, XmNdragCallback, SliderMoveCB, NULL );
     XtAddCallback( widFader, XmNvalueChangedCallback, SliderMoveCB, NULL );

     xmTmpStr = XmStringCreateLtoR(" Quit ", 
				XmSTRING_DEFAULT_CHARSET);

     widQuit = XtVaCreateManagedWidget ( "quit_button",
				       xmPushButtonWidgetClass,
				       widForm,
				       XmNlabelString, xmTmpStr,
				       XmNleftAttachment, XmATTACH_FORM,
				       XmNtopAttachment, XmATTACH_WIDGET,
				       XmNtopWidget, widFader,
				       XmNleftOffset, LEFT_OFFSET,
				       XmNtopOffset, VERT_OFFSET_P,
				       NULL );				       

     XtAddCallback( widQuit, XmNactivateCallback, QuitCB, NULL );
     XmStringFree(xmTmpStr);

     XtRealizeWidget( widTopLevel );

     XtAppMainLoop( appContext );

}


void SliderMoveCB( Widget w, caddr_t ClientData, caddr_t pos ) {
int	iTmp;

	XmScaleGetValue( (Widget) w, (int *) &iTmp);
	SetInten( (BYTE)iTmp );
	return;
}

void QuitCB( ) {
	SetInten( MaxInten );	/* sicherheitshalber wieder zuruecksetzen */
	exit( 0 );
}
