/*
 *	Bind an interface to an IPX network.
 *
 *
 */

#include <stdio.h>
#include <stdlib.h> 
#include <sys/socket.h>
#include <linux/sockios.h>
#include <linux/ipx.h>

void main(int argc,char *argv[])
{
	int sock;
	long net;
		
	if(argc!=2)
	{
		fprintf(stderr,"%s <network>\n",argv[0]);
		exit(1);
	}
	
	if(sscanf(argv[1],"%ld",&net)==0)
	{
		fprintf(stderr,"Unable to parse network number '%s'.\n",argv[1]);
		exit(1);
	}

	net=htonl(net);
		
	sock=socket(AF_IPX,SOCK_DGRAM,PF_IPX);
	if(sock==-1)
	{
		perror("socket");
		exit(1);
	}
	
	if(ioctl(sock,SIOCDELRT,(void *)&net)==-1)
	{
		perror("del route");
		exit(1);
	}
}
