/*
 *	Bind an interface to an IPX network.
 *
 *
 */

#include <stdio.h>
#include <stdlib.h> 
#include <sys/socket.h>
#include <linux/sockios.h>
#include <linux/ipx.h>

void main(int argc,char *argv[])
{
	int sock;
	int size;
	char buf[1024];
	struct sockaddr_ipx ipxs;
	int opt=1;
	
	sock=socket(AF_IPX,SOCK_DGRAM,PF_IPX);
	if(sock==-1)
	{
		perror("socket");
		exit(1);
	}
	
	if(setsockopt(sock,SO_DEBUG,SOL_SOCKET,&opt,sizeof(opt))==-1)
	{
		perror("setsockopt");
		exit(1);
	}
	
	ipxs.sipx_family=AF_IPX;
	ipxs.sipx_network=htonl(0);
	ipxs.sipx_port=htons(0x453);
	
	if(bind(sock,&ipxs,sizeof(ipxs))==-1)
	{
		perror("bind");
		exit(1);
	}
	
	while(1)
	{
		int sz;
		size=recvfrom(sock,buf,sizeof(buf),0,&ipxs,&sz);
		if(size==-1)
		{
			perror("recvfrom");
			exit(1);
		}
		printf("RIP on network %ld\n",htonl(ipxs.sipx_network));
	}
}

