/*
 *	A quick test program that sends SAP response frames 
 *	(for a ficticious WOMBAT-1000 server)
 */

#include <stdio.h>
#include <stdlib.h> 
#include <sys/socket.h>
#include <linux/sockios.h>
#include <linux/ipx.h>

typedef struct
{
/* Novell stuff is written to 8086 style packing rules so you tend to
   get a lot of this crap... Still at least gcc allows you to tweak
   structure alignments */
	short Code __attribute__ ((packed));
	unsigned long Network __attribute__ ((packed));
	unsigned short HopCount __attribute__ ((packed));
	unsigned short Ticks __attribute__ ((packed));
} RipPacket;

void main(int argc,char *argv[])
{
	int sock;
	struct sockaddr_ipx ipxs;
	int opt=1;
	static RipPacket s;
	
	sock=socket(AF_IPX,SOCK_DGRAM,PF_IPX);
	if(sock==-1)
	{
		perror("socket");
		exit(1);
	}
#ifdef DEBUG_IT	
	/* Socket debugging */
	if(setsockopt(sock,SOL_SOCKET,SO_DEBUG,&opt,sizeof(opt))==-1)
	{
		perror("setsockopt");
		exit(1);
	}
#endif	
	/* Permit broadcast output */
	if(setsockopt(sock,SOL_SOCKET,SO_BROADCAST, &opt,sizeof(opt))==-1)
	{
		perror("setsockopt");
		exit(1);
	}
	
	/* This is a special for IPX sockets that allows the superuser
	   to change the IPX type field of a socket */
	   
	opt=1;		/* Remember no htons! - its a byte */
	
	if(setsockopt(sock,SOL_SOCKET,SO_TYPE,&opt,sizeof(opt))==-1)
	{
		perror("setsockopt");
		exit(1);
	}
	
	
	ipxs.sipx_family=AF_IPX;
	ipxs.sipx_network=htonl(65530);
	ipxs.sipx_port=htons(0x453);
	
	if(bind(sock,&ipxs,sizeof(ipxs))==-1)
	{
		perror("bind");
		exit(1);
	}
	
	memcpy(ipxs.sipx_node,"\377\377\377\377\377\377",6);
	s.Code=htons(2);	/* Response */
	s.Network=htonl(65530);
	s.HopCount=htons(1);
	s.Ticks=htons(6);

	while(1)
	{	
		if(sendto(sock,(void *)&s,sizeof(s),0,&ipxs,sizeof(ipxs))==-1)
		{
			perror("sendto");
			exit(1);
		}
		printf("Rip!\n");
		sleep(60);
	}
}

