/*
 *	A quick test program that sends SAP response frames 
 *	(for a ficticious WOMBAT-1000 server). Hardcoded to assume we are
 *	on network 0x1B for now (as are the other demo's).
 */

#include <stdio.h>
#include <stdlib.h> 
#include <sys/socket.h>
#include <linux/sockios.h>
#include <linux/ipx.h>

typedef struct
{
/* Novell stuff is written to 8086 style packing rules so you tend to
   get a lot of this crap... Still at least gcc allows you to tweak
   structure alignments */
	short Type __attribute__ ((packed));
	char Name[48] __attribute__ ((packed));
	unsigned long Network __attribute__ ((packed));
	unsigned char Node[6] __attribute__ ((packed));
	unsigned short Socket __attribute__ ((packed));
	unsigned short HopCount __attribute__ ((packed));
} SapRecord;

typedef struct
{
	short Code __attribute__ ((packed));
	SapRecord s1 __attribute__ ((packed));
	SapRecord s2 __attribute__ ((packed));
} SapPacket;

void main(int argc,char *argv[])
{
	int sock;
	struct sockaddr_ipx ipxs;
	int opt=1;
	static SapPacket s;
	
	sock=socket(AF_IPX,SOCK_DGRAM,PF_IPX);
	if(sock==-1)
	{
		perror("socket");
		exit(1);
	}
	
	/* Socket debugging */
#ifdef DEBUG
	if(setsockopt(sock,SOL_SOCKET,SO_DEBUG,&opt,sizeof(opt))==-1)
	{
		perror("setsockopt");
		exit(1);
	}
#endif	
	/* Permit broadcast output */
	if(setsockopt(sock,SOL_SOCKET,SO_BROADCAST, &opt,sizeof(opt))==-1)
	{
		perror("setsockopt");
		exit(1);
	}
	
	/* This is a special for IPX sockets that allows the superuser
	   to change the IPX type field of a socket */
	   
	opt=0/*4*/;	/* Remember no htons! - its a byte */
	
	if(setsockopt(sock,SOL_SOCKET,SO_TYPE,&opt,sizeof(opt))==-1)
	{
		perror("setsockopt");
		exit(1);
	}
	
	ipxs.sipx_family=AF_IPX;
	ipxs.sipx_network=htonl(65530);
	ipxs.sipx_port=htons(0x452);
	
	if(bind(sock,&ipxs,sizeof(ipxs))==-1)
	{
		perror("bind");
		exit(1);
	}
	
	memcpy(ipxs.sipx_node,"\377\377\377\377\377\377",6);
	s.Code=htons(2);	/* Response */
	s.s1.Type=htons(4);	/* File server */
	strcpy(s.s1.Name,"THE-INCREDIBLE-KILLER-FRIDGE");
	s.s1.Network=htonl(65530);
	memcpy(s.s1.Node,"\000\000\xC0\xC2\xF6\x60",6);
	s.s1.Socket=htons(0x451);
	s.s1.HopCount=htons(1);
	s.s2.Type=htons(0x47);
	s.s2.Network=htonl(65530);
	s.s2.Socket=htons(0x8041);
	s.s2.HopCount=htons(2);
	memcpy(s.s2.Node,"\000\000\xC0\xC2\xF6\x60",6);
	strcpy(s.s2.Name,"FOOBIE-11");

	while(1)
	{	
		if(sendto(sock,(void *)&s,sizeof(s),0,&ipxs,sizeof(ipxs))==-1)
		{
			perror("sendto");
			exit(1);
		}
		printf("Parp!\n");
		sleep(60);
	}
}

