#!/bin/sh
#************************************************************************
#*   IRC - Internet Relay Chat, ircd/mkversion.sh
#*   Copyright (C) 1990 Chelsea Ashley Dyerman
#*
#*   This program is free software; you can redistribute it and/or modify
#*   it under the terms of the GNU General Public License as published by
#*   the Free Software Foundation; either version 1, or (at your option)
#*   any later version.
#*
#*   This program is distributed in the hope that it will be useful,
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#*   GNU General Public License for more details.
#*
#*   You should have received a copy of the GNU General Public License
#*   along with this program; if not, write to the Free Software
#*   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#*/
# 14 Jul 1990 - Jto
# Applied Gonzo's fixes..
#
# 30 May 1990 - Jto
# Changed Kimmo Suominen's mail address.
# Added Heikki Piirainen's fix to creation
#
# $Header$
# $Log$

if [ ! -f version.c ]
then
	generation=0
else
	generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c`
	if [ ! "$generation" ]; then generation=0; fi
fi

generation=`expr $generation + 1`
creation=`date | awk '{if (NF == 6) { print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } else { print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`
cat > version.c <<EOF
/*
 *   IRC - Internet Relay Chat, ircd/version.c
 *   Copyright (C) 1990 Chelsea Ashley Dyerman
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * This file is generated by mkversion.sh. Any changes made will go away.
 */

#include "struct.h"
#include "patchlevel.h"

char *generation = "$generation";
char *creation = "$creation";
char *version = PATCHLEVEL;

char *infotext[] =
    {
	"Based on the original code written by Jarkko Oikarinen",
	"Copyright 1988,1989 University of Oulu, Computing Center",
	"",
	"This program is free software; you can redistribute it and/or",
	"modify it under the terms of the GNU General Public License as",
	"published by the Free Software Foundation; either version 1, or",
	"(at your option) any later version.",
	"",
	"The following persons have made many changes and enhancements to the",
	"code and may know how IRC really works if you have questions about it:",
	"",
	"WiZ          Jarkko Oikarinen         jto@tolsun.oulu.fi",
	"Msa          Markku Savela            Markku.Savela@vtt.fi",
	"Misha        Mike Bolotski            mikeb@salmon.ee.ubc.ca",
	"Chelsea      Chelsea Ashley Dyerman   casie@earth.CChem.Berkeley.EDU",
	"Wumpus       Greg Lindahl             gl8f@astsun.astro.virginia.edu",
	"",
	"Those who helped in prior versions and continue to be helpful:",
	"",
	"             Markku Jarvinen          mta@tut.fi",
	"Kim          Kimmo Suominen           kim@lut.fi",
	"             Jeff Trim                jtrim@orion.cair.du.edu",
	"Vijay        Vijay Subramaniam        vijay@lll-winken.llnl.gov",
	"             Karl Kleinpaste          karl@cis.ohio-state.edu",
	"Wisner       Bill Wisner              wisner@hayes.fai.alaska.edu",
	"             Tom Davis                conslt16@zeus.unl.edu",
	"",
	"Various modifications, bugreports, cleanups by:",
	"",
	"             Hugo Calendar            hugo@!ucscl.ucsc.edu",
	"             Bo Adler                 beau@through.cs.caltech.edu",
	"BigCheese    Michael Sandrof          ms5n+@andrew.cmu.edu",
	"             Jon Solomon              jsol@buit5.bu.edu",
	"             Jan Peterson             jlp@hamblin.byu.edu",
	"",
	"Alpha and beta testers, who put up with our bugs, and such:",
	"",
	"Trillian     Helen Rose               hrose@uceng.uc.edu",
	"",
	"Thanks also goes to those persons not mentioned here who have added",
	"their advice, opinions, and code to IRC.",
	0,
    };

EOF

exit 0
