/* $Header: /vol/dwb/src/mumail-2.4b/RCS/MuGeneric.h,v 1.2 1994/03/31 17:57:59 dwb Exp $ */
/*
 * $Log: MuGeneric.h,v $
 * Revision 1.2  1994/03/31  17:57:59  dwb
 *  MuMail 2.4 Beta
 *
 * Revision 1.1  1993/11/15  18:52:38  dwb
 * Initial revision
 *
 *
 */

/*---------------------------------------------------------------------------+
| This file is part of Mumail, 
| Copyright (c) 1992-1993 by Muhammad M. Saggaf.
| Copyright (c) 1994 by David W. Boyd. All rights reserved
|
| See the file COPYING (1-COPYING) or the manual page mumail(1)
| for a full statement of rights and permissions.
+---------------------------------------------------------------------------*/

/*                               -*- Mode: C -*- 
 * MuGeneric.h --- Generic routines (header file)
 * Author          : Muhammad M. Saggaf
 * Created On      : April 1993
 * Last Modified By: system admin
 * Last Modified On: Tue Jun 29 23:32:26 1993
 * Update Count    : 18
 * Status          : Mostly OK, needs some cleaning up
 */

#include <stdio.h>

#ifndef __P
#ifdef __STDC__
#define __P(args) args
#define DOTDOTDOT ...
#else
#define __P(args) ()
#define DOTDOTDOT
#endif
#endif

extern String
                CopyStreamToBuffer __P((FILE *stream, String prependS)),
                SimpleCopyStreamToBuffer __P((FILE *stream)),
                CopyFileToBuffer __P((String fileName)),
                CopyPipeToBuffer __P((String command)),
                PrependToBuffer __P((String buffer, String string)),

                FileInHomeDir __P((String fileName)),
                FileInMailDir __P((String fileName)),
                ExpandTilda __P((String fileName)),
                PureFromPackedName __P((String name)),

                CurrentLocalTimeString __P((void)),
                CurrentArpaDate __P((void)),

                UserName __P((void)),

                FmtString __P((char *,...)),

                FilterString __P((String string, String unwanted, char replacement)),
                StripStringB __P((String string)),
                StripStringE __P((String string)),
                StripStringA __P((String string)),
                CleanSimpleCommentedBuffer __P((String buffer)),
                CloneString __P((String *copy, String orig)),

                NextWord __P((String line)),

                Strstr __P((String heyStack, String needle)),
                CaseStrstr __P((String heyStack, String needle)),
                strend __P((char *string));

extern int

                OpenPFile __P((FILE **file, String name, String mode)),
                ClosePFile __P((FILE *file, String name)),

                WriteToPipe __P((int *pd, String data, int size)),
                ReadFromPipe __P((int *pd, String data, int size)),

                AppendBufferToFile __P((String fileName, String buffer)),
                AppendFileToStream __P((String file, FILE *stream)),
                AppendFileToFile __P((String file1, String file2)),

                PipeBufferToCommand __P((String command, String buffer)),

                BackupFile __P((String fileName)),

                FileExists __P((String name)),
                FileReadable __P((String name)),
                IsRegularFile __P((String name)),
                FileIsCompressed __P((String name)),
                FileIsGZipped __P((String name)),

                MuSystem __P((String cmd)),
                ExternalEditFile __P((String fileName)),

                ElapsedUTimeGreater __P((long unsigned int usec)),
                ElapsedMTimeGreater __P((long unsigned int msec)),

                CaseStrSame __P((String string1, String string2)),
                CaseNStrSame __P((String string1, String string2, int n)),
                GetNthLinePos __P((String buffer, int n));

extern void 
                FreeList __P((XtPointer *listArr)),

                MuError __P((char *msg)),
                MuNotice __P((char *msg)),
                MuPError __P((char *msg)),

                MuProcessEvent __P((Widget widget));

#define FileIsPacked(name) (FileIsCompressed(name) || FileIsGZipped(name))

#define TmpString(str) FmtString(str)

#define CNULL       ('\0')
#define SPACE       (' ')
#define NEWLINE     ('\n')
#define TAB         ('\t')

