	.file "mem.S"

 # Prototype: memcpy4to3( void *dest, void *src, int n )
 # Copies pixels from 4-byte-per-pixel screen to 3-byte-per-pixel screen,
 # discarding the last byte of each pixel.
 # Only uses 32-bit aligned word accesses.
 # Instructions have been shuffled a bit for possible avoidance of
 # pipeline hazards.

.text
	.align 4

.globl _memcpy4to3
_memcpy4to3:
	pushl %ebp
	movl %esp,%ebp
	pushl %edi
	pushl %esi
	pushl %ebx
	pushl %ecx
	movl 8(%ebp),%edi	# destination address
	movl 12(%ebp),%esi	# source address
	movl 16(%ebp),%ecx	# number of pixels

	# Handle chunks of 8 pixels.
1:	cmpl $8,%ecx
	jl 2f

	movl (%esi),%eax	# pixel 0
	movl 4(%esi),%ebx	# pixel 1
	shll $8,%eax		# BGR0 in 8-31
	shrd $8,%ebx,%eax	# BGR0 in 0-23, B1 in 24-31
	movl %eax,(%edi)	# write word
	shll $8,%ebx		# GR1 in 16-31
	movl 8(%esi),%eax	# pixel 2
	shrd $16,%eax,%ebx	# GR1 in 0-15, BG2 in 16-31
	movl %ebx,4(%edi)	# write word
	shll $8,%eax		# move R2 into 24-31
	movl 12(%esi),%ebx	# pixel 3
	shrd $24,%ebx,%eax	# R2 in 0-7, BGR3 in 8-31
	movl %eax,8(%edi)	# write word

	movl 16(%esi),%eax	# pixel 4
	shll $8,%eax		# BGR4 in 8-31
	movl 20(%esi),%ebx	# pixel 5
	shrd $8,%ebx,%eax	# BGR4 in 0-23, B5 in 24-31
	movl %eax,12(%edi)	# write word
	shll $8,%ebx		# GR5 in 16-31
	movl 24(%esi),%eax	# pixel 6
	shrd $16,%eax,%ebx	# GR5 in 0-15, BG6 in 16-31
	movl %ebx,16(%edi)	# write word
	shll $8,%eax		# move R6 into 24-31
	movl 28(%esi),%ebx	# pixel 7
	shrd $24,%ebx,%eax	# R6 in 0-7, BGR7 in 8-31
	movl %eax,20(%edi)	# write word

	addl $32,%esi
	addl $24,%edi
	subl $8,%ecx
	jmp 1b

2:	# Do the remaining pixels.

	andl %ecx,%ecx
	jz 4f			# none left

3:	movl (%esi),%eax
	movw %eax,(%edi)
	shrl $16,%eax
	movb %al,2(%edi)
	addl $4,%esi
	addl $3,%edi
	decl %ecx
	jnz 3b

4:
	popl %ecx
	popl %ebx
	popl %esi
	popl %edi
	popl %ebp
	ret
