.\" +----------
.\" |
.\" |		UIT/UITPS/UITCMP man page. Release 4.1b. April 1994
.\" |
.\" |		Copyright 1993, 1994 by Tudor Hulubei & Andrei Pitis.
.\" |
.\" |	This file is part of UIT (UNIX Interactive Tools)
.\" |
.\" |	UIT is free software; you can redistribute it and/or modify it under
.\" | the terms of the GNU General Public License as published by the Free
.\" | Software Foundation; either version 2, or (at your option) any later
.\" | version.
.\" |
.\" | UIT is distributed in the hope that it will be useful, but WITHOUT ANY 
.\" | WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
.\" | FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
.\" | details.
.\" |
.\" | You should have received a copy of the GNU General Public License along
.\" | with UIT; see the file COPYING. If not, write to the Free Software
.\" | Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
.\" |
.\" |
.TH uit 1 "April 1994" "Release 4.1b"
.SH NAME
uit \- UNIX Interactive Tools version 4.1b 
.SH SYNTAX
.I uit
.br
.I uitps
.IR "" "  [" ps (1)
like parameters]
.br
.I uitview
filename
.br
.I uitcmp
.IR "" "  "
file1 file2

.SH DESCRIPTION
.I uit
is a
.B file system browser
with some shell facilities which was designed to make your work much
easier and much efficient.

.I uitps
is an interactive process viewer/killer. It calls internally the
.IR ps (1)
utility so that's the reason why
.I uitps
parameters are in fact
.IR ps (1)
ones. No more manual is provided for
.I uitps
because running it is self explanatory. Use the
arrows, PageUp, PageDown, Home, End, ^y, ^b, ^ku, ^kv, + and - to move in
the list, r to refresh it and F10 or ^C to leave.

.I uitview
is a hex/ascii file viewer. Too simple to need a manual page. Use the
arrows, PageUp, PageDown, Home, End, ^y, ^b, ^ku, ^kv, + and - to move in
the file, r to refresh the screen and F10 or ^C to leave.

.I uitcmp
is a file compare utility. It outputs to
.BR stderr ,
.I uit
catching its error messages this way.
.I uitcmp
was designed to be used in
.B "$HOME/.uitrc"
.BR "" ( uit
configuration file) and should not be used as a stand alone program.

.SH FILE-SYSTEM BROWSER
.I uit
is made of two panels. The left one and the right one. Each
one contains a file system directory. You can browse the
directory tree with the usual cursor keys and pressing
.B ENTER
when you want to enter or leave a directory.
You may change the panels by pressing
.BR TAB .
See also 
.BR "BUILT-IN COMMANDS" .

.SH COMMAND LINE
Under the two panels there is a shell like command line which
you can use to type normal shell commands. The command line
supports up to 256 characters and 32 commands in the history
list.
See also 
.BR "BUILT-IN COMMANDS" .

.SH WARNINGS AND ERRORS REPORTING
There is a status bar under the command line. You can see there
the status of the currently executed command, the warnings and
errors and you will be prompted if a decision has to be taken.

.SH CONFIGURATION FILES
There are two configuration files in
.IR uit / uitps
:
.B .uitrc
and
.BR .uittermcap .
Their place is in the user's
.B HOME
directory, but
.I uit
(and
.IR uitps )
can work without them (except if you are connected to a Linux
system with a serial b/w tty; see
.B BUGS
below). I don't recommend working without the
.B .uitrc
configuration file since it contains very useful key definitions.

.br
The
.B .uittermcap
is a
.BR "local termcap database" ,
which allows
.IR uit / uitps
to find very fast the termcap description of the terminal specified
in the
.B TERM
environment variable. You can copy your terminal description
from
.B /etc/termcap
and put it in the
.B .uittermcap
because
.B /etc/termcap
is ussualy a very large and hard to search file.

.I uit
uses
.B .uittermcap
to find a terminal description
.B *BEFORE*
trying to read
.BR /etc/termcap .
If
.B .uittermcap
is found in the user's
.B HOME
directory,
.B /etc/termcap
will be ignored. The main advantage of the
.B .uittermcap
file is that it allows faster access and can be modified without special
permission. You can use only one of
.B .uittermcap
and
.B /etc/termcap
at a time. Take care: if you are using
.B .uittermcap
and your terminal description can't be found there,
.I uit
will fail because the
.B /etc/termcap
database won't be searched. See also  
.BR BUGS .

The configuration file
.B .uitrc
is the file
.I uit
searches each time it is started, trying to configure itself reading it.
.I uit
searches it in the home directory and the current directory. If
this file can't be found,
.I uit
will use the defaults.
The configuration file is structured on sections, each section
containing variables in the following format:

.in +.5i
.B variable_name
=
.BR first_field ; second_field ; " ..."
.in -.5i

After the variable_name at least one space or tab is required.
All characters after a 
.BR "" \' # \'
will be ignored and if you comment
a section name, the whole section will be ignored.

The configuration file contains the following sections:

.B "1. [Setup]"

In this section the variables have only one field.

a. 
.B TempDirectory
.br
 - this variable specifies the location of the temporary files created by
.BR uit .

b.
.B LinuxConsole
.br
 - this variable should be set to
.B ON
on
.B Linux
systems if you are working on a
.BR "Linux virtual tty" .
If you are connected to a
.B Linux
system with a serial b/w tty, you should set this to
.BR OFF .
.B LinuxConsole
is meaningless if
.I uit
was compiled without
.BR "" ' HAVE_LINUX "'."

c.
.B ColorMonitor
.br
 - this variable should be set to
.B ON
on
.B Linux
systems if you are working on a
.B "Linux virtual tty"
and you have a
.BR "color monitor" .
If your monitor is
.BR monochrome ,
you should set this to
.BR OFF .
.B ColorMonitor
is meaningless if
.I uit
was compiled without
.BR "" ' HAVE_LINUX '
or
.B LinuxConsole
is
.BR OFF .

If
. B LinuxConsole
and
.B ColorMonitor
are both
.BR ON ,
.B [UITxxx-Color]
sections
will be used in the configuration file
.BR .uitrc .
Otherwise,
.I uit
will use the
.B [UITxxx-Monochrome]
sections.
The discussion above applies to both
.I uit
and
.I uitps
utilities.

.B "2. [UIT-Setup]"

In this section the variables have only one field.

a. 
.B StartupFileDisplayMode
 - this variable specifies the file specific information
that will be displayed at startup. It can be any of 
.B OwnerGroup
,
.B DateTime
,
.B Size
,
.B Mode
or
.BR FullName .
 - this value initially affects both panels but it can be changed separately
afterwards.

b. 
.B StartupLeftPanelPath
.br
c.
.B StartupRightPanelPath
 - those variables specifies the startup path for each panel.

d.
.B NormalModeHelp
.br
e.
.B CommandLineModeHelp
 - those variables describe the status bar contents for each
.I uit
mode when no errors occurred. See also
.BR <ShowTty> .

f.
.B ErrorLogDirectory
 - this variable specifies the directory into which the files containing
redirected standard output and standard error of the commands using
.B hide
option resides. 

.B "2. [UITxxx-Color] / [UITxxx-Monochrome]"

In this sections the variables have only one field.

These sections permits you to customize the colors of
.I uit
and
.IR uitps .
Reading the
.B .uitrc
configuration file should be self explanatory.
See also the
.B [Setup]
section.

.B "3. [Keys]"

This section describes the actions
.I uit
takes when a specified
key is pressed. In this section a variable could have up to 6
fields separated by \';\'.
Each line in this section will look like:

.BR key_name " " "" = " " "" command_name ; formatted_command ; new_dir ;
.br
.BR "           " "" save_screen ; pause ; hide

.B WARNING
: you can't continue the variable fields description on the next line.


a.
.B key_name
 -
.B key_name
is the name of the key associated with the given command. Only the keys
listed in the configuration file can be used.

b.
.B command_name
 -
.B command_name
is a command generic name. Even if it is not always used, the
.B command_name
must be present (if a command is associated with
.BR key_name ).
If it is not, no action will be taken when pressing
.B key_name.
There are two types of commands in
.I uit
:
.B built-in
commands and
.B user defined
commands.
.B Built-in
commands
are specified between <>
.BR "" ( <Copy> , " " "" <RenameMove> , " " "" <MkDir>
etc) and if the
.B command_name
section contains a built-in command specification, the other fields are
ignored.


The
.B BUILT-IN COMMANDS
are:

.B <Copy>
 - copies files from one panel to another.

.B <RenameMove>
 - moves files from one panel to another.

.B <MkDir>
 - makes directories.

.B <Delete>
 - deletes files and empty directories.

.B <Exit>
 - exits
.IR uit .

.B <HistoryBack>
 - copies to the command line the previous command in the history list.

.B <ShowTty>
 - switches between the two
.I uit
modes (starting with Linux 0.99.12 this option is completely used only if
you are super user because normal users can't do a screen dump).

.B <Refresh>
 - refreshes the contents of the current panel.

.B <GotoRoot>
 - changes the current directory to root.

.B <SwitchPanels>
 - switches the left panel with the right one.

.B <HistoryNext>
 - copies the next command in the history list to the command line.

.B <FileDisplayMode>
 - changes the file display mode.

.B <DeleteCmdLn>
 - deletes the command line contents.

.B <FileSelect>
 - selects/unselects files. All the files can be selected by pressing
.BR "" ' + '
(and ENTER) or unselected by pressing
.BR "" ' - "'."
By pressing
.BR "" ' * '
selected files becomes unselected and unselected files becomes selected.

.B <CopyFileToCmdLn>
 - copies to the command line the current file name .

.B <Home>
 - puts the cursor onto the first entry in the current directory list.

.B <End>
 - puts the cursor onto the last entry in the current directory list.

.B <PageUp>
 - puts the cursor up one page in the current directory file list.

.B <PageDown>
 - puts the cursor down one page in the current directory file list.

.B <CursorLeft>
 - acts like
.BR <PageUp> .

.B <CursorRight>
 - acts like
.BR <PageDown> .

.B <CursorUp>
 - puts the cursor up one entry in the current directory file list.

.B <CursorDown>
 - puts the cursor down one entry in the current directory file list.

.B <ChangePanel>
 - puts the cursor in the other panel.

c.
.B formatted_command
 -
.B formatted_command
is a shell command which can contain some scanf like format specifiers.
With their help you can get the current directory entry name (the directory
entry under the cursor), owner, group and mode. These are the available
.BR "format specifiers" :

 -
.B %s{question,default_answer}
.br
When
.I uit
encounters a
.B %s
in the formatted_command
asks the user the question 'question' whose default
answer is 'default_answer' and replaces the
.B %s{ , }
with the user answer. Both 'question' and 'default_answer' could
contain any other format specifiers except
.BR %s .

.B WARNING
: no spaces between
.B %s
and
.BR "" \' { \' "" .

 -
.B %f
.br
.I uit
will replace
.B %f
with the current directory entry name only if it is a file (not a directory).

 -
.B %d
.br
.I uit
will replace 
.B %d
with the current directory entry name only if it is a directory (not a file).

 -
.B %l
.br
.I uit
will replace
.B %l
with the current directory entry name only if it is a symbolic link.

 -
.B %t
.br
.I uit
will replace
.B %t
with the current directory entry name only if it is a named pipe.

 -
.B %z
.br
.I uit
will replace
.B %z
with the current directory entry name only if it is a socket.

 -
.B %a
.br
.I uit
will always replace
.B %a
with the current directory entry name.

 -
.B %m
.br
.I uit
will always replace
.B %m
in the formatted_command with the current file mode.

 -
.B %g
.br
.I uit
will always replace
.B %g
in the formatted_command with the current file group.

 -
.B %o
.br
.I uit
will always replace
.B %o
in the formatted_command with the current file owner.

 -
.B %p
.br
.I uit
will always replace
.B %p
in the formatted_command with the current panel path.

 -
.B %b
.br
.I uit
will always replace
.B %b
in the formatted_command with the current panel directory name.
.br

Using
.B uppercase format specifiers
you will be able to access the other panel path, file and directory names.

d.
.B new_dir
 - if the
.B formatted_command
successfully exits (exit code = 0) and this field is present then
.B new_dir
will become the current panel directory.

e.
.B save_screen
 - this field is an integer (usually 0 or 1) who tells
.I uit
to save (1) or not to save (0) the terminal screen
after executing the
.B formatted_command.
Saving the screen is not necessary while editing or viewing a 
file because the information left after the editor or
the viewer exits is not important. Saving the screen 
means that that screen will be restored before the
execution of the next command. This field is used only if you are
super user under Linux and you are working on a virtual console.
By default this field is 1.

f.
.B pause
 - for some commands you may wish to read their results	before
repainting the panels. If this field is present
.I uit
will wait for a key to be pressed before restoring the panels.
By default this field is 0.

g.
.B hide
 - there are some commands that aren't displaying any
useful information if successfully complete their
execution: mount, chmod, chown, chgrp, sync ... and if
an error occurs then a line or two are sended to
stderr.	If this option is 1, the stdout and stderr
will be redirected to some files
.BR "" ( stdout.pid
and
.B stderr.pid
, where
.B pid
is
.I uit
.IR pid )
and only if the command exit code is not 0, the
.B stderr.pid
file will be displayed, line by line, onto the status bar. This
way the panels will not be deleted and then repainted
and the command appears to be built-in. 
.B stdout.pid
and
.B stderr.pid
are created in the
.B TempDirectory
specified in the
.B [Setup]
section. By default this field is 0.

The default configuration file
.B "$HOME/.uitrc"
supports most of the usual commands. To find out more about them please
read it.
.I uit
allows you to change both the utility used to perform
a particular operation (using compress instead of gzip :-) ) and
the key associated with it. There is also possible to
.BR remove / add
new commands.

.SH CANCELING OPERATIONS
Built-in cyclic operations can be stopped by pressing
.BR ^C .
.br
.I uit
can be suspended by pressing
.BR ^Z .

.SH MOUSE SUPPORT
.I uit
doesn't use the mouse, but, if you are running Linux, you can use the
.B selection
utility to get characters form screen and insert them in the terminal
keyboard queue.

.SH MINUSES
.B "1."
Files can't be moved from a file system to another. You have
to copy then delete them instead. Before trying to make a
link from the destination file to the source file,
.I uit
deletes the destination file (if existent), so take care not
to lose some data trying to move files in a wrong way.

.B "2."
Background execution is not fully supported. That means you
may specify an 
.B &
terminated command line in the
configuration file but the result of the background executed
command (stdout and stderr redirection, as explained before)
will be overwritten by the result of newer commands and, if
an error occurs, you will not see it.

.B "3."
No command line editing is provided. You can only modify the contents
of the command line by appending new characters or deleting them with
backspace.

.B "4."
When
.I uit
is compiled for
.BR Linux ,
the default built-in color descriptions are for color monitors,
so you can't (decently) run
.I uit
on a b/w monitor without the
.B .uitrc
file.
.B .uitrc
should be configured with
.BR "ColorMonitor = OFF" .
If you are working on a serial b/w tty,
.B LinuxConsole
should be
.B OFF
too.

.B "5."
Only
.B POSIX
terminals are supported.

.B "6."
No 
.B terminfo
support is provided. No problems, you can use the
.B .uittermcap
file to get termcap support.

.SH BUGS
.B "1."
.B ku, kd, kr and kl
terminal capabilities for
.B vt100
family sends
.B "ESC ] A"
,
.B "ESC ] B"
,
.B "ESC ] C"
and
.BR "ESC ] D"
(normal mode). Every
.B /etc/termcap
I saw defines these capabilities as
.B "ESC O A"
,
.B "ESC O B"
,
.B "ESC O C"
and
.BR "ESC O D"
(application mode). This is not a very big problem because you can copy the
.B vt100
termcap description in the
.B .uittermcap
file and modify it to suit your terminal key codes.

.B "2."
Only the
.B ANSI
.BR "" ' cm '
terminal capability is supported. So, if your
.B cm
capability is not
.BR "ESC [%i%d;%dH" ,
.I uit
won't work. In order to make
.I uit
work with a different
.B cm
definition a small modification is required in
.B tty.c
(
.BR "tty_cursormove(int, int)" )
to suit your
.BR "" ' cm '
definition.

Please send bug reports to
.I tudor@ulise.cs.pub.ro

.SH SEE ALSO
termcap(5) ps(1)

.SH FILES
/usr/bin/uit
.br
/usr/bin/uitps
.br
/usr/bin/uitview
.br
/usr/bin/uitcmp
.br
/usr/man/man1/uit.1
.br
$HOME/.uitrc
.br
$HOME/.uittermcap

.SH AUTHORS
.I Tudor Hulubei
.br
.I Andrei Pitis
.br
.B Politechnic University of Bucharest
.br
.B Romania
