/*
**
** xtail.c (Version 1.01)
** Grafisches Interface fuer das Unix tail Kommando
** Linux 0.99.14, OSF/Motif 1.2.3
**
** Klaus Thiele (linuxNet: lupo!oblib!kth)
** Huenstetten, 1994
**
** Die grafische Oberflaeche dieses Programms wurde mit dem
** Motif-Interface-Designer 'MIND' erstellt.
** (Created by MIND (c), FLUX GbR Berlin, 1993)
** Andere Programmteile basieren auf Beispielen aus dem Buch
** 'X und Motif' (Gottheil, Kaufmann, Kern, Zhao)
** Einfuehrung in die Programmierung des Motif-Toolkits und des 
** X-Window-Systems
** 
*/

#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeB.h>
#include <Xm/PushB.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
#include <Xm/FileSB.h>
#include <Xm/MessageB.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>

#include "xtail.h"

#define APPL_CLASS "XTail"

FormData  formData;
Arg     gargs[5];
int     gn = 0;

static Widget xtail_Create(Widget parent);
static void fileCB(Widget parent, Cardinal data, XmPushButtonCallbackStruct *cbs);
static void quitCB(Widget parent, FormData data, XmPushButtonCallbackStruct *cbs);
static void clearCB(Widget parent, FormData data, XmPushButtonCallbackStruct *cbs);
static void AddText(Widget text_widget, String string);
static void ReadPipe(caddr_t client_data, int *file_descr, XtInputId *id);
static void FileboxOkCB(Widget parent, FormData data, XmFileSelectionBoxCallbackStruct *cbs);
static void FileOpenCB( String file, FormData data );
static void Exec(String file, FormData formData);


void main(Cardinal argc,char **argv)
{
  XtAppContext appContext;
  Widget Toplevel, MainDialog;

  Toplevel =  XtAppInitialize(
     				(XtAppContext *)	&appContext, 
				(String)	 	APPL_CLASS,
				(XrmOptionDescList)	NULL,
				(Cardinal)		0,
     				(int *)			&argc,
     				(String *)		argv,
     				(String *)		NULL,
     				(ArgList)		NULL,
     				(Cardinal)		0 );

  MainDialog = xtail_Create(Toplevel);

  XtManageChild(MainDialog);
  XtRealizeWidget(Toplevel);

  gn = 0;
  XtSetArg( gargs[gn], XmNdialogTitle, XmStringCreate("XTail Version 1.01", XmSTRING_DEFAULT_CHARSET) ); gn++;
  XtSetValues( formData->wForm, gargs, gn );
  formData->appContext = &appContext;  

  XtAppMainLoop( appContext );
}


static Widget xtail_Create(Widget parent)
{
  Arg args[40];
  Cardinal n;
  Widget widForm;
  Widget widText;
  Widget PD_Menubar;
  Widget widMenuFile;
  Widget widMenuFile_SubId;
  Widget widMenuOpen;
  Widget xtail_PD_Menubar_File_SEP;
  Widget widMenuExit;
  Widget widMenuEdit;
  Widget widMenuEdit_SubId;
  Widget widMenuClear;

  formData     = (FormData)XtCalloc( 1, sizeof(FormDataArea) );

  n = 0;
  XtSetArg(args[n], XmNwidth, 700); n++;
  XtSetArg(args[n], XmNheight, 465); n++;
  widForm = XmCreateForm(parent, "mainForm", args, n);

  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(args[n], XmNy, 0); n++;
  PD_Menubar = XmCreateMenuBar(widForm, "Pulldown", args, n);
  XtManageChild(PD_Menubar);

  n = 0;
  widMenuFile = XmCreateCascadeButton(PD_Menubar, "menuFileButton", args, n);
  widMenuFile_SubId = XmCreatePulldownMenu(PD_Menubar, "Pulldown", args, n);

  n = 0;
  widMenuOpen = XmCreatePushButton(widMenuFile_SubId, "menuOpenButton", args, n);
  XtManageChild(widMenuOpen);

  n = 0;
  xtail_PD_Menubar_File_SEP = XmCreateSeparator(widMenuFile_SubId, "MenuSeparator", args, n);
  XtManageChild(xtail_PD_Menubar_File_SEP);

  n = 0;
  widMenuExit = XmCreatePushButton(widMenuFile_SubId, "menuExitButton", args, n);
  XtManageChild(widMenuExit);

  XtVaSetValues(widMenuFile, XmNsubMenuId, widMenuFile_SubId, NULL);
  XtManageChild(widMenuFile);

  n = 0;
  widMenuEdit = XmCreateCascadeButton(PD_Menubar, "menuEditButton", args, n);
  widMenuEdit_SubId = XmCreatePulldownMenu(PD_Menubar, "Pulldown", args, n);

  n = 0;
  widMenuClear = XmCreatePushButton(widMenuEdit_SubId, "menuClearButton", args, n);
  XtManageChild(widMenuClear);

  XtVaSetValues(widMenuEdit, XmNsubMenuId, widMenuEdit_SubId, NULL);
  XtManageChild(widMenuEdit);

  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNx, 11); n++;
  XtSetArg(args[n], XmNy, 42); n++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNwidth, 682); n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_SELF); n++;
  XtSetArg(args[n], XmNheight, 413); n++;
  XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT ); n++;
  XtSetArg(args[n], XmNeditable, FALSE ); n++;
  XtSetArg(args[n], XmNscrollHorizontal, FALSE); n++;
  widText = XmCreateScrolledText(widForm, "outputArea", args, n);
  XtManageChild(widText);

  XtAddCallback(widMenuOpen, XmNactivateCallback, (XtCallbackProc) fileCB, NULL);
  XtAddCallback(widMenuExit, XmNactivateCallback, (XtCallbackProc) quitCB, formData);
  XtAddCallback(widMenuClear, XmNactivateCallback, (XtCallbackProc) clearCB, formData);

  formData->wText      = widText;
  formData->wForm      = widForm;

  return widForm;
}

static void  fileCB(Widget parent,  Cardinal data,  XmPushButtonCallbackStruct *cbs){
  Widget fileBox, fileBoxHelpButton;
  Arg arg[10];
  int n;
  XmString xmTmpStr[4];
  
  xmTmpStr[0] = XmStringCreate( "Datei Auswahl", XmSTRING_DEFAULT_CHARSET );
  xmTmpStr[1] = XmStringCreate( "Verzeichnisse", XmSTRING_DEFAULT_CHARSET );
  xmTmpStr[2] = XmStringCreate( "Dateien", XmSTRING_DEFAULT_CHARSET );
  xmTmpStr[3] = XmStringCreate( "Auswahl", XmSTRING_DEFAULT_CHARSET );

  n = 0;
  XtSetArg( arg[n], XmNdialogTitle, xmTmpStr[0] ); n++;
  XtSetArg( arg[n], XmNdirListLabelString, xmTmpStr[1] ); n++;
  XtSetArg( arg[n], XmNfileListLabelString, xmTmpStr[2] ); n++;
  XtSetArg( arg[n], XmNfilterLabelString, xmTmpStr[3] ); n++;
  fileBox = XmCreateFileSelectionDialog(XtParent(parent), "fileBox", arg, n);
  fileBoxHelpButton = XmFileSelectionBoxGetChild( fileBox, XmDIALOG_HELP_BUTTON );
  XtUnmanageChild( fileBoxHelpButton );
  XtManageChild(fileBox);

  for( n = 0; n < 4; n++ )
     XmStringFree( xmTmpStr[n] );

  /* It's tricky: XtDestroyWidget is a Motif function. In this case,   */
  /* XtDestroyWidget destroys the FileBox-Widget, that's what we want. */

  XtAddCallback(fileBox, XmNcancelCallback, (XtCallbackProc)XtDestroyWidget, NULL);

  /* Double-click or activate 'OK'-Button: Jump to FileboxOkCB,        */

  XtAddCallback(fileBox, XmNokCallback, (XtCallbackProc)FileboxOkCB, formData);

}

static void   quitCB(Widget parent,  FormData data,   XmPushButtonCallbackStruct *cbs){
    if( data->pid != 0 )
    {
       XtRemoveInput( data->out_Id );
       XtRemoveInput( data->err_Id );
       killpg( data->pid, SIGINT );
    }

   exit( 0 );
}

static void   clearCB(Widget parent,  FormData data,   XmPushButtonCallbackStruct *cbs){
   XmTextSetString( data->wText, "" );
   return;
}

static void AddText(Widget text_widget, String string)
{
 int length;
 int rows;
 int i;
 char *text;
 Arg arg[1];
 Cardinal n;
 
#define MAX_ROWS 200

   length = XmTextGetLastPosition(text_widget);
   XmTextReplace(text_widget,length,length,string);
   
   n = 0;
   XtSetArg(arg[n],XmNvalue,&text); n++;    
   XtGetValues(text_widget,arg,n);
   length = XmTextGetLastPosition(text_widget);
   rows = 0;
   
   for( i = length; i > 0; i-- )
   {
     if( text[i] == '\n')
     {
       rows++;
       if( rows == MAX_ROWS )
       {
         XmTextReplace(text_widget,0,i+1,"");
         XmTextSetInsertionPosition(text_widget,0);
         break;
       }
     }
   }
   length = XmTextGetLastPosition(text_widget);
   XmTextSetInsertionPosition(text_widget,length);
}

static void ReadPipe(caddr_t client_data, int *file_descr, XtInputId *id)
{
 Widget text_widget = (Widget)client_data;
 char buffer[BUFSIZ];
 int count;

   count = read(*file_descr, buffer, BUFSIZ-1 );
   if( count == 0 ) return;
   buffer[count] = '\0';
   AddText(text_widget,buffer);
   return;
}

static void FileboxOkCB(Widget parent, FormData data, XmFileSelectionBoxCallbackStruct *cbs)
{
  String fileString;
  String dirString;

  XmStringGetLtoR(cbs->dir, XmSTRING_DEFAULT_CHARSET, &dirString);
  XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &fileString);

  XtDestroyWidget(parent);

  FileOpenCB( fileString, data );

  return;
}

static void FileOpenCB( String file, FormData data ) 
{
  XmString  xmTmpStr[2];
  Arg       args[5];
  Cardinal  n;

  if( strlen(file) == 0 ) return;

  if( access(file, R_OK) == -1 ) {
    Widget    Dialog;

    xmTmpStr[0] = XmStringCreate( "Error", XmSTRING_DEFAULT_CHARSET );
    xmTmpStr[1] = XmStringCreate( "can't open file!", XmSTRING_DEFAULT_CHARSET );
    n = 0;
    XtSetArg( args[n], XmNdialogTitle, xmTmpStr[0] ); n++;
    XtSetArg( args[n], XmNmessageString, xmTmpStr[1] ); n++;
    XtSetArg( args[n], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL); n++;
    Dialog = XmCreateErrorDialog(data->wForm, "ErrorBox", args, n);
    XtManageChild(Dialog);
    XmStringFree( xmTmpStr[0] );
    XmStringFree( xmTmpStr[1] );

  } else {

    char tmpStr[128];

    if( data->pid != 0 )
    {
       XtRemoveInput( data->out_Id );
       XtRemoveInput( data->err_Id );
       killpg( data->pid, SIGINT );
       data->pid = 0;
    }

    Exec( file, data );

    data->out_Id = XtAppAddInput( *data->appContext, data->out_child,
                                (XtPointer)XtInputReadMask,
                                (XtInputCallbackProc)ReadPipe, 
                                (XtPointer)data->wText );
    data->err_Id = XtAppAddInput( *data->appContext, data->err_child,
                                (XtPointer)XtInputReadMask,
                                (XtInputCallbackProc)ReadPipe, 
                                (XtPointer)data->wText );

    sprintf( tmpStr, "XTail: %s", file );
    xmTmpStr[0] = XmStringCreate( tmpStr, XmSTRING_DEFAULT_CHARSET ); 
    n = 0;
    XtSetArg( args[n], XmNdialogTitle, xmTmpStr[0] ); n++;
    XtSetValues( data->wForm, args, n );
    XmStringFree( xmTmpStr[0] );
  }

  return;
}

static void Exec(String file, FormData formData)
{
 int out_child[2];
 int err_child[2];
 pid_t pid;
 
   pipe(out_child);
   pipe(err_child);
   
   pid = fork();
   if( pid > 0 ) {
     /* alter prozess */
     formData->pid = pid;
     formData->out_child = out_child[0];
     close(out_child[1]);

     formData->err_child = err_child[0];
     close(err_child[1]);

   } else if( pid == 0 ) {

       /* der neue prozess */
       close(0);
 
       close(1);
       dup(out_child[1]);
       close(out_child[0]);
 
       close(2);
       dup(err_child[1]);
       close(err_child[0]);
       
       pid = getpid( );
       setpgid( pid, pid );
       execlp( "tail", "tail", "-f", file, NULL);
      } else {
       XtWarning("Prozess kann nicht gestartet werden!");
      }
}       
